// C. Herzog fuer Grundlagen der Programmierung, 1.12.2004

class OrderedListIntSetEnumeration extends IntEnumeration {
    // direkter Zugriff auf das Attribut list der zugehrigen Menge:
    private OrderedIntList list;

    // das Attribut list der zugehrigen Menge wird als Parameter bergeben:
    public OrderedListIntSetEnumeration(OrderedIntList list) {
	this.list = list;
    }

    public boolean hasMoreElements() {
	// genau dann, wenn Liste nicht leer ist:
	return list != null;
    }

    public int nextElement() {
	// vor dem Weiterschalten Inhalt merken:
	int i = list.getItem();
	// weiterschalten:
	list = list.getNext();
	// gemerkten Inhalt ausliefern:
	return i;
    }
}
